unit dll_ssparser_function;

interface
uses
  Windows,
  SysUtils,
  dnako_import ,//in 'hi_unit\dnako_import.pas',
  dnako_import_types ,//in 'hi_unit\dnako_import_types.pas',
  dll_plugin_helper ,//in 'hi_unit\dll_plugin_helper.pas',
  Ssparser;
type
  TNakoSsparser=Class(TSsParser)
    public
      InstanceVar:PHiValue;
    end;
function parse_commad(HandleArg: DWORD): PHiValue; stdcall;

implementation
  function parse_commad(HandleArg: DWORD): PHiValue; stdcall;
  var
    obj, group, command, value,s: PHiValue;
    cmd: string; i: Integer;
    p:TNakoSsparser;
  begin
    Result := nil;

    group   :=nako_getFuncArg(HandleArg,0);
    command :=nako_getFuncArg(HandleArg,1);
    value   :=nako_getFuncArg(HandleArg,2);

    cmd:=LowerCase(hi_str(command));
    if cmd = 'create' then
    begin
      p := TNakoSsParser.Create(nil);
      p.InstanceVar := group;
      Result := hi_newInt(Integer(p));
    end else
    begin
      // IuWFNg
      obj := nako_group_findMember(group, 'IuWFNg');
      if obj = nil then raise Exception.Create('IuWFNgł܂B');
      i   := hi_int(obj);
      p := TNakoSsparser(Integer(i));

      if cmd = 'eimset' then
      begin
        if hi_int(value)<>0 then
          p.EscapeInvalidMeta:=true
        else
          p.EscapeInvalidMeta:=False
      end else if cmd = 'eimget' then
      begin
        if p.EscapeInvalidMeta then
          result:=hi_newInt(1)
        else
          result:=hi_newInt(0);
      end else if cmd = 'leset' then
      begin
        if hi_int(value)<>0 then
          p.LeaveEscape:=true
        else
          p.LeaveEscape:=False;
      end else if cmd = 'leget' then
      begin
        if p.EscapeInvalidMeta then
          result:=hi_newInt(1)
        else
          result:=hi_newInt(0);
      end else if cmd = 'tagset' then
        p.TagPattern.SetText(PChar(hi_str(value)))
      else if cmd = 'tagget' then
        result:=hi_newStr(String(p.TagPattern.GetText))
      else if cmd = 'metaset' then
        p.MetaPattern.SetText(PChar(hi_str(value)))
      else if cmd = 'metaget' then
        result:=hi_newStr(String(p.MetaPattern.GetText))
      else if cmd = 'isset' then
      begin
        p.InputString:=hi_str(value);

        s:=nako_group_findMember(group,'͗vf');
        if s=nil then raise Exception.Create('͗vfł܂B');
        nako_var_free(s);
        nako_ary_create(s);
        for i:=0 to p.Count-1 do
          nako_ary_add(s,hi_newstr(p.str[i]));

        s:=nako_group_findMember(group,'͎');
        if s=nil then raise Exception.Create('͎ʂł܂B');
        nako_var_free(s);
        nako_ary_create(s);
        for i:=0 to p.Count-1 do
        begin
          case p.MarkUptype[i] of
           mtTag   :nako_ary_add(s,hi_newstr('^O'));
           mtMeta  :nako_ary_add(s,hi_newstr('^'));
           mtTagerr:nako_ary_add(s,hi_newstr('G['));
           mtStr   :nako_ary_add(s,hi_newstr(''));
          end;
        end
      end
      else if cmd = 'isget' then
        result:=hi_newStr(p.InputString)
      else if cmd = 'match' then
      begin
        result:=hi_newInt(p.Match(hi_str(nako_ary_get(value,0)),hi_str(nako_ary_get(value,1))));
      end else if cmd = 'getparam' then
      begin
        result:=hi_newStr(p.Getparam(hi_str(nako_ary_get(value,0)),hi_int(nako_ary_get(value,1))));
      end else if cmd = 'escparam' then
      begin
        result:=hi_newStr(p.EscapeParam(hi_str(value)));
      end;
    end;

  end;

end.

